## percona-mysql-shell 8.0.32-1

=== debian/changelog ===
percona-mysql-shell (8.0.32-1-1) unstable; urgency=medium

  * Update to new upstream release 8.0.32-1-1

 -- ubuntu-cloud-user <mysql-build@oss.oracle.com>  Wed, 15 Mar 2023 18:31:16 +0000

percona-mysql-shell (8.0.32-1ubuntu18.04) bionic; urgency=low

  * New Release. For release notes, please refer to
    https://dev.mysql.com/doc/relnotes/percona-mysql-shell/8.0/en/news-8.0.32.html

 -- MySQL Release Engineering <mysql-build@oss.oracle.com>  Wed, 15 Mar 2023 17:53:14 +0000
